Index: /code/branches/rocket/src/modules/weapons/RocketController.cc
===================================================================
--- /code/branches/rocket/src/modules/weapons/RocketController.cc	(revision 6809)
+++ /code/branches/rocket/src/modules/weapons/RocketController.cc	(revision 6810)
@@ -30,4 +30,5 @@
 #include "projectiles/SimpleRocket.h" 
 #include "util/Math.h"
+#include "weapons/projectiles/SimpleRocket.h"
 
 
@@ -66,5 +67,5 @@
 
 		rocket->rotateYaw(0.2);
-			rocket->moveFrontBack(2);
+			//rocket->moveFrontBack(2);
 
     }
@@ -72,6 +73,6 @@
 
 
-	void setRocket(SimpleRocket* rocket, RocketController* contr) {
-			contr->setControllableEntity(dynamic_cast<ControllableEntity*> rocket);
-	}
+	//void setRocket(SimpleRocket* rocket, RocketController* contr) {
+	//		contr->setControllableEntity(dynamic_cast<ControllableEntity*> rocket);
+	//}
 }
Index: /code/branches/rocket/src/modules/weapons/RocketController.h
===================================================================
--- /code/branches/rocket/src/modules/weapons/RocketController.h	(revision 6809)
+++ /code/branches/rocket/src/modules/weapons/RocketController.h	(revision 6810)
@@ -30,5 +30,5 @@
 #define _RocketController_H__
 
-#include "OrxonoxPrereqs.h"
+#include "weapons/WeaponsPrereqs.h"
 
 #include "controllers/Controller.h"
@@ -44,5 +44,5 @@
         Oli Scheuss
     */
-    class _OrxonoxExport RocketController : public Controller, public Tickable
+    class _WeaponsExport RocketController : public Controller, public Tickable
     {
         public:
Index: /code/branches/rocket/src/modules/weapons/projectiles/SimpleRocket.cc
===================================================================
--- /code/branches/rocket/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 6809)
+++ /code/branches/rocket/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 6810)
@@ -61,5 +61,5 @@
 		RocketController* myRController = new RocketController(this);
 		this->setController(myRController);
-		myRController->setRocket(this, myRController);
+		//myRController->setRocket(this, myRController);
 		
 		//this->getController()->setControllableEntity(this);
@@ -70,12 +70,12 @@
         if (GameMode::isMaster())
         {
-            this->setCollisionType(WorldEntity::Kinematic);
-            this->setVelocity(0,0,-100);
+         /*   this->setCollisionType(WorldEntity::Kinematic);
+            this->setVelocity(0,0,-100);*/
 
             Model* model = new Model(this);
             model->setMeshSource("Rocket.mesh");
-            model->scale(0.7f);
+            //model->scale(0.7f);
             this->attach(model);
-            ParticleEmitter* fire = new ParticleEmitter(this);
+           /* ParticleEmitter* fire = new ParticleEmitter(this);
             this->attach(fire);
             fire->setOrientation(this->getOrientation());
@@ -89,5 +89,5 @@
             collisionShape->setRadius(3);
             collisionShape->setHeight(500);
-            this->attachCollisionShape(collisionShape);
+            this->attachCollisionShape(collisionShape);*/
 
             this->destroyTimer_.setTimer(this->lifetime_, false, createExecutor(createFunctor(&SimpleRocket::destroyObject, this)));
@@ -96,5 +96,5 @@
     }
 
-    /**
+    /**s
     @brief
         Destructor. Destroys controller, if present and kills sounds, if playing.
Index: /code/branches/rocket/src/modules/weapons/weaponmodes/SimpleRocketFire.cc
===================================================================
--- /code/branches/rocket/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 6809)
+++ /code/branches/rocket/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 6810)
@@ -46,10 +46,10 @@
         RegisterObject(SimpleRocketFire);
 
-        this->reloadTime_ = 0.20f;
+      /*  this->reloadTime_ = 0.20f;
         this->bParallelReload_ = false;
         this->damage_ = 100;
         this->speed_ = 500;
 
-        this->setMunitionName("LaserMunition");
+        this->setMunitionName("LaserMunition");*/
         // The firing sound of the Rocket is played in Rocket.cc (because of OpenAl sound positioning)
     }
@@ -63,5 +63,5 @@
         SimpleRocket* rocket = new SimpleRocket(this);
 
-        this->computeMuzzleParameters(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn()->getAimPosition());
+      /*  this->computeMuzzleParameters(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn()->getAimPosition());
         rocket->setOrientation(this->getMuzzleOrientation());
         rocket->setPosition(this->getMuzzlePosition());
@@ -70,5 +70,5 @@
 
         rocket->setOwner(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn());
-        rocket->setDamage(this->getDamage());
+        rocket->setDamage(this->getDamage());*/
     }
 }