Index: /code/branches/chat2/data/gui/layouts/ChatBox-inputonly.layout
===================================================================
--- /code/branches/chat2/data/gui/layouts/ChatBox-inputonly.layout	(revision 6870)
+++ /code/branches/chat2/data/gui/layouts/ChatBox-inputonly.layout	(revision 6870)
@@ -0,0 +1,16 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<GUILayout >
+    <Window Type="DefaultWindow" Name="orxonox/ChatBox-inputonly/Root" >
+        <Property Name="InheritsAlpha" Value="False" />
+        <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+        <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
+        <Window Type="MenuWidgets/Editbox" Name="orxonox/ChatBox-inputonly/input" >
+            <Property Name="Text" Value="" />
+            <Property Name="AlwaysOnTop" Value="True" />
+            <Property Name="MaxTextLength" Value="1073741823" />
+            <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+            <Property Name="UnifiedAreaRect" Value="{{0.02,0},{0,5},{0.98,0},{0,30}}" />
+        </Window>
+    </Window>
+</GUILayout>
Index: /code/branches/chat2/data/gui/layouts/ChatBox.layout
===================================================================
--- /code/branches/chat2/data/gui/layouts/ChatBox.layout	(revision 6869)
+++ /code/branches/chat2/data/gui/layouts/ChatBox.layout	(revision 6870)
@@ -2,5 +2,5 @@
 
 <GUILayout >
-    <Window Type="DefaultWindow" Name="Root" >
+    <Window Type="DefaultWindow" Name="orxonox/ChatBox/Root" >
         <Property Name="InheritsAlpha" Value="False" />
         <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
Index: /code/branches/chat2/data/gui/scripts/ChatBox-inputonly.lua
===================================================================
--- /code/branches/chat2/data/gui/scripts/ChatBox-inputonly.lua	(revision 6870)
+++ /code/branches/chat2/data/gui/scripts/ChatBox-inputonly.lua	(revision 6870)
@@ -0,0 +1,5 @@
+-- ChatBox-inputonly.lua
+
+local P = createMenuSheet("ChatBox-inputonly")
+return P
+
Index: /code/branches/chat2/src/orxonox/ChatInputHandler.cc
===================================================================
--- /code/branches/chat2/src/orxonox/ChatInputHandler.cc	(revision 6869)
+++ /code/branches/chat2/src/orxonox/ChatInputHandler.cc	(revision 6870)
@@ -46,4 +46,6 @@
   SetConsoleCommandAlias( ChatInputHandler, activate_static, "startchat",
     true );
+  SetConsoleCommandAlias( ChatInputHandler, activate_small_static, 
+    "startchat_small", true );
 
 
@@ -58,6 +60,7 @@
     assert( this->inpbuf != NULL );
 
-    /* MARK add generation of ChatBox thingy here */
+    /* generate chatbox ui and chatbox-inputonly ui */
     GUIManager::getInstance().loadGUI( "ChatBox" );
+    GUIManager::getInstance().loadGUI( "ChatBox-inputonly" );
 
     /* configure the input buffer */
@@ -66,8 +69,4 @@
     this->inputState = InputManager::getInstance().createInputState( "chatinput", false, false, InputStatePriority::Dynamic );
     this->inputState->setKeyHandler(this->inpbuf);
-
-    //[> set console shortcut <]
-    //this->getIdentifier()->addConsoleCommand(createConsoleCommand(createFunctor(
-      //&ChatInputHandler::activate, this), "startchat"), false);
   }
 
@@ -99,4 +98,6 @@
     /* get window pointers */
     input = CEGUI::WindowManager::getSingleton().getWindow( "orxonox/ChatBox/input" );
+    inputonly = CEGUI::WindowManager::getSingleton().getWindow( "orxonox/ChatBox-inputonly/input" );
+
     CEGUI::Window *history = CEGUI::WindowManager::getSingleton().getWindow( "orxonox/ChatBox/history" );
     lb_history = dynamic_cast<CEGUI::Listbox*>(history); 
@@ -109,7 +110,10 @@
   /* activate, deactivate */
   void ChatInputHandler::activate_static()
-  { ChatInputHandler::getInstance().activate(); }
-  
-  void ChatInputHandler::activate()
+  { ChatInputHandler::getInstance().activate( true ); }
+
+  void ChatInputHandler::activate_small_static()
+  { ChatInputHandler::getInstance().activate( false ); }
+
+  void ChatInputHandler::activate( bool full )
   {
     /* start listening */
@@ -118,5 +122,8 @@
 
     /* MARK add spawning of chat widget stuff here.*/
-    GUIManager::getInstance().showGUI( "ChatBox" );
+    if( full )
+      GUIManager::getInstance().showGUI( "ChatBox" );
+    else
+      GUIManager::getInstance().showGUI( "ChatBox-inputonly" );
   }
 
@@ -128,4 +135,5 @@
     /* MARK add un-spawning of chat widget stuff here. */
     GUIManager::getInstance().hideGUI( "ChatBox" );
+    GUIManager::getInstance().hideGUI( "ChatBox-inputonly" );
   }
 
@@ -146,4 +154,5 @@
     /* set the text */
     this->input->setProperty( "Text", left + "|" + right );
+    this->inputonly->setProperty( "Text", left + "|" + right );
   }
 
Index: /code/branches/chat2/src/orxonox/ChatInputHandler.h
===================================================================
--- /code/branches/chat2/src/orxonox/ChatInputHandler.h	(revision 6869)
+++ /code/branches/chat2/src/orxonox/ChatInputHandler.h	(revision 6870)
@@ -73,5 +73,5 @@
 
       /* cegui stuff */
-      CEGUI::Window *input;
+      CEGUI::Window *input, *inputonly;
       CEGUI::Listbox *lb_history;
 
@@ -83,5 +83,6 @@
       /* start listening, stop listening */
       static void activate_static();
-      void activate();
+      static void activate_small_static();
+      void activate( bool full );
       void deactivate();
 