Index: /code/branches/presentation3/src/modules/weapons/projectiles/SimpleRocket.cc
===================================================================
--- /code/branches/presentation3/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 7018)
+++ /code/branches/presentation3/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 7019)
@@ -64,5 +64,5 @@
 
         if (GameMode::isMaster())
-       {
+        {
             this->setCollisionType(WorldEntity::Kinematic);
             this->fuel_=true;
@@ -100,6 +100,9 @@
 
         SUPER(SimpleRocket, tick, dt);
-        if (this->getVelocity().squaredLength() >130000) this->maxLife_-=dt; //if Velocity bigger than about 360, uses a lot more "fuel" :)
-        
+        if ( GameMode::isMaster() )
+        {
+            if (this->getVelocity().squaredLength() >130000)
+                this->maxLife_-=dt; //if Velocity bigger than about 360, uses a lot more "fuel" :)
+            
 
             this->setAngularVelocity(this->getOrientation() * this->localAngularVelocity_);
@@ -108,18 +111,24 @@
 
             
-            if (this->fuel_) {
+            if (this->fuel_)
+            {
                 if (this->destroyTimer_.getRemainingTime()<  this->lifetime_-this->maxLife_ ) 
                     this->fuel_=false;
-            } else this->disableFire();
+            }
+            else 
+                this->disableFire();
 
             if( this->bDestroy_ )
                 this->destroy();
+        }
                 
     }
 
-    void SimpleRocket::disableFire(){
-        this->setAcceleration(0,0,0);        
-        this->fire_->detachFromParent();
-
+    void SimpleRocket::disableFire()
+    {
+        this->setAcceleration(0,0,0);
+        this->fire_->destroy();
+        this->fire_ = 0;
+//         this->fire_->detachFromParent();
     }
 
@@ -132,6 +141,9 @@
         if (this->isInitialized()) 
         {
-            this->getController()->destroy();
-            COUT(4)<< "simplerocket destroyed\n";
+            if( GameMode::isMaster() )
+            {
+                this->getController()->destroy();
+                COUT(4)<< "simplerocket destroyed\n";
+            }
         }
     }
@@ -204,30 +216,4 @@
         }
     }
-    
-
-    void SimpleRocket::fired(unsigned int firemode)
-    {
-        if (this->owner_)
-        {
-            {
-                ParticleSpawner* effect = new ParticleSpawner(this->owner_->getCreator());
-                effect->setPosition(this->getPosition());
-                effect->setOrientation(this->getOrientation());
-                effect->setDestroyAfterLife(true);
-                effect->setSource("Orxonox/explosion4");
-                effect->setLifetime(2.0f);
-            }
-
-            {
-                ParticleSpawner* effect = new ParticleSpawner(this->owner_->getCreator());
-                effect->setPosition(this->getPosition());
-                effect->setOrientation(this->getOrientation());
-                effect->setDestroyAfterLife(true);
-                effect->setSource("Orxonox/smoke4");
-                effect->setLifetime(3.0f);
-            }
-            this->destroy();
-        }
-    }
 
     /**
Index: /code/branches/presentation3/src/modules/weapons/projectiles/SimpleRocket.h
===================================================================
--- /code/branches/presentation3/src/modules/weapons/projectiles/SimpleRocket.h	(revision 7018)
+++ /code/branches/presentation3/src/modules/weapons/projectiles/SimpleRocket.h	(revision 7019)
@@ -122,6 +122,5 @@
             inline float getDamage() const
                 { return this->damage_; }
-            virtual void fired(unsigned int firemode);
-			
+
 
         private:
Index: /code/branches/presentation3/src/modules/weapons/weaponmodes/SimpleRocketFire.cc
===================================================================
--- /code/branches/presentation3/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 7018)
+++ /code/branches/presentation3/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 7019)
@@ -46,5 +46,5 @@
         RegisterObject(SimpleRocketFire);
 
-        this->reloadTime_ = 4;
+        this->reloadTime_ = 1;
         this->bParallelReload_ = false;
         this->damage_ = 100;