Index: trunk/configure.ac
===================================================================
--- trunk/configure.ac	(revision 7032)
+++ trunk/configure.ac	(revision 7033)
@@ -626,4 +626,5 @@
                  src/Makefile
                  src/lib/Makefile
+                 src/lib/math/Makefile
                  src/lib/graphics/Makefile
                  src/lib/graphics/importer/Makefile
Index: trunk/src/Makefile.am
===================================================================
--- trunk/src/Makefile.am	(revision 7032)
+++ trunk/src/Makefile.am	(revision 7033)
@@ -4,4 +4,5 @@
 include world_entities/Makefile.am
 include story_entities/Makefile.am
+include lib/BuildLibs.am
 
 #"-O3 -pedantic -fPIC -ffast-math -I/usr/X11R6/include"
@@ -13,41 +14,9 @@
 
 orxonox_DEPENDENCIES = \
-		lib/libORXlibs.a \
 		util/libORXutils.a \
-		lib/gui/gtk_gui/libORXgui.a \
-		lib/graphics/importer/libORXimporter.a \
-		lib/graphics/importer/libtc.a \
-		lib/graphics/libORXgraphics.a \
-		lib/sound/libORXsound.a \
-		lib/event/libORXevent.a \
-		lib/physics/libORXphysics.a \
-		lib/particles/libORXparticles.a \
-		lib/collision_detection/libORXcd.a \
-		lib/graphics/spatial_separation/libORXquadtree.a \
-		lib/parser/tinyxml/libtinyxml.a \
-		lib/parser/ini_parser/libIniParser.a \
-		lib/gui/gl_gui/libORXglgui.a \
-		lib/shell/libORXshell.a \
-		lib/network/libORXnet.a
+		$(libORXlibs_a_LIBRARIES_)
 
 orxonox_LDADD = util/libORXutils.a \
-		\
-		lib/collision_detection/libORXcd.a \
-		\
-		lib/libORXlibs.a \
-		lib/gui/gtk_gui/libORXgui.a \
-		lib/graphics/importer/libORXimporter.a \
-		lib/graphics/importer/libtc.a \
-		lib/graphics/libORXgraphics.a \
-		lib/sound/libORXsound.a \
-		lib/event/libORXevent.a \
-		lib/physics/libORXphysics.a \
-		lib/particles/libORXparticles.a \
-		lib/graphics/spatial_separation/libORXquadtree.a \
-		lib/parser/tinyxml/libtinyxml.a \
-		lib/parser/ini_parser/libIniParser.a \
-		lib/gui/gl_gui/libORXglgui.a \
-		lib/shell/libORXshell.a \
-		lib/network/libORXnet.a \
+		$(libORXlibs_a_LIBRARIES_) \
 		$(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
 
Index: trunk/src/lib/BuildLibs.am
===================================================================
--- trunk/src/lib/BuildLibs.am	(revision 7033)
+++ trunk/src/lib/BuildLibs.am	(revision 7033)
@@ -0,0 +1,20 @@
+LIB_PREFIX=lib
+
+libORXlibs_a_LIBRARIES_ = \
+                $(LIB_PREFIX)/libORXlibs.a \
+                $(LIB_PREFIX)/gui/gtk_gui/libORXgui.a \
+                $(LIB_PREFIX)/gui/gl_gui/libORXglgui.a \
+                $(LIB_PREFIX)/graphics/importer/libORXimporter.a \
+                $(LIB_PREFIX)/graphics/libORXgraphics.a \
+                $(LIB_PREFIX)/graphics/importer/libtc.a \
+                $(LIB_PREFIX)/sound/libORXsound.a \
+                $(LIB_PREFIX)/event/libORXevent.a \
+                $(LIB_PREFIX)/physics/libORXphysics.a \
+                $(LIB_PREFIX)/particles/libORXparticles.a \
+                $(LIB_PREFIX)/collision_detection/libORXcd.a \
+                $(LIB_PREFIX)/network/libORXnet.a \
+                $(LIB_PREFIX)/graphics/spatial_separation/libORXquadtree.a \
+                $(LIB_PREFIX)/parser/tinyxml/libtinyxml.a \
+                $(LIB_PREFIX)/parser/ini_parser/libIniParser.a \
+                $(LIB_PREFIX)/shell/libORXshell.a \
+                $(LIB_PREFIX)/math/libORXmath.a
Index: trunk/src/lib/Makefile.am
===================================================================
--- trunk/src/lib/Makefile.am	(revision 7032)
+++ trunk/src/lib/Makefile.am	(revision 7033)
@@ -4,88 +4,45 @@
 noinst_LIBRARIES = libORXlibs.a
 
-libORXlibs_a_DEPENDENCIES = gui/gtk_gui/libORXgui.a \
-                            gui/gl_gui/libORXglgui.a \
-                            graphics/importer/libORXimporter.a \
-                            graphics/libORXgraphics.a \
-                            sound/libORXsound.a \
-                            event/libORXevent.a \
-                            physics/libORXphysics.a \
-                            particles/libORXparticles.a \
-                            collision_detection/libORXcd.a \
-			    network/libORXnet.a \
-                            graphics/spatial_separation/libORXquadtree.a \
-                            parser/tinyxml/libtinyxml.a \
-                            parser/ini_parser/libIniParser.a \
-                            shell/libORXshell.a
+libORXlibs_a_SOURCES = \
+		coord/p_node.cc \
+		lang/base_object.cc \
+		lang/class_list.cc \
+		data/data_tank.cc \
+		util/substring.cc \
+		util/color.cc \
+		util/helper_functions.cc \
+		util/multi_type.cc \
+		util/executor/executor.cc
 
-#libORXlibs_a_LIBDADD =     gui/gtk_gui/libORXgui.a \
-                            gui/gl_gui/libORXglgui.a \
-                            graphics/importer/libORXimporter.a \
-                            graphics/libORXgraphics.a \
-                            sound/libORXsound.a \
-                            event/libORXevent.a \
-                            physics/libORXphysics.a \
-                            particles/libORXparticles.a \
-                            collision_detection/libORXcd.a \
-			    network/libORXnet.a \
-                            graphics/spatial_separation/libORXquadtree.a \
-                            shell/libORXshell.a \
-                            $(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
+noinst_HEADERS = \
+		coord/p_node.h \
+		lang/base_object.h \
+		data/data_tank.h \
+		graphics/render2D/element_2d.h \
+		graphics/render2D/render_2d.h \
+		lang/class_list.h \
+		util/substring.h \
+		util/array.h \
+		util/list.h \
+		util/t_stack.h \
+		util/color.h \
+		util/helper_functions.h \
+		util/multi_type.h \
+		util/executor/executor.h \
+		util/executor/executor_specials.h \
+		util/executor/functor_list.h \
+		util/count_pointer.h
 
-libORXlibs_a_SOURCES =  coord/p_node.cc \
-                        lang/base_object.cc \
-                        lang/class_list.cc \
-                        data/data_tank.cc \
-                        util/substring.cc \
-                        util/color.cc \
-                        util/helper_functions.cc \
-                        util/multi_type.cc \
-                        util/executor/executor.cc \
-                        math/vector.cc \
-                        math/quaternion.cc \
-                        math/vector2D.cc \
-                        math/matrix.cc \
-                        math/curve.cc \
-                        math/line.cc \
-                        math/plane.cc \
-                        math/rotation_OBSOLETE.cc
-
-noinst_HEADERS =        coord/p_node.h \
-                        lang/base_object.h \
-                        data/data_tank.h \
-                        graphics/render2D/element_2d.h \
-                        graphics/render2D/render_2d.h \
-                        lang/class_list.h \
-                        util/substring.h \
-                        util/array.h \
-                        util/list.h \
-                        util/t_stack.h \
-                        util/color.h \
-                        util/helper_functions.h \
-                        util/multi_type.h \
-                        util/executor/executor.h \
-                        util/executor/executor_specials.h \
-                        util/executor/functor_list.h \
-			util/count_pointer.h \
-                        math/vector.h \
-                        math/quaternion.h \
-                        math/vector2D.h \
-                        math/matrix.h \
-                        math/curve.h \
-                        math/line.h \
-                        math/plane.h \
-                        math/rotation_OBSOLETE.h
-
-
-SUBDIRS = graphics \
-          sound \
-          event \
-          physics \
-          particles \
-          collision_detection \
-	        network \
-          parser \
-          shell \
-          gui \
-          .
-
+SUBDIRS = \
+	math \
+	graphics \
+	sound \
+	event \
+	physics \
+	particles \
+	collision_detection \
+	network \
+	parser \
+	shell \
+	gui \
+	.
Index: trunk/src/lib/math/Makefile.am
===================================================================
--- trunk/src/lib/math/Makefile.am	(revision 7033)
+++ trunk/src/lib/math/Makefile.am	(revision 7033)
@@ -0,0 +1,25 @@
+MAINSRCDIR=../..
+include $(MAINSRCDIR)/defs/include_paths.am
+
+
+noinst_LIBRARIES = libORXmath.a
+
+libORXmath_a_SOURCES = \
+		vector.cc \
+		vector2D.cc \
+		quaternion.cc \
+		matrix.cc \
+		curve.cc \
+		plane.cc \
+		line.cc \
+		rotation_OBSOLETE.cc
+
+noinst_HEADERS = \
+		vector.h \
+		vector2D.h \
+		quaternion.h \
+		matrix.h \
+		curve.h \
+		plane.h \
+		line.h \
+		rotation_OBSOLETE.h
Index: trunk/src/story_entities/game_world_data.cc
===================================================================
--- trunk/src/story_entities/game_world_data.cc	(revision 7032)
+++ trunk/src/story_entities/game_world_data.cc	(revision 7033)
@@ -30,5 +30,5 @@
 #include "camera.h"
 #include "environment.h"
-#include "terrain.h"
+#include "terrain.h"storyI
 #include "test_entity.h"
 #include "terrain.h"
Index: trunk/src/story_entities/story_entity.cc
===================================================================
--- trunk/src/story_entities/story_entity.cc	(revision 7032)
+++ trunk/src/story_entities/story_entity.cc	(revision 7033)
@@ -81,4 +81,6 @@
 
 
+
+  // so we can also do these things in the Campaign. (will be overwritten from the entities file)
   LoadParam(root, "description", this, StoryEntity, setDescription)
       .describe("Sets the description of this StoryEntity");