Index: /code/branches/presentation3/data/levels/includes/pickups.oxi
===================================================================
--- /code/branches/presentation3/data/levels/includes/pickups.oxi	(revision 7037)
+++ /code/branches/presentation3/data/levels/includes/pickups.oxi	(revision 7038)
@@ -1,7 +1,8 @@
+
 <!-- Shield pickups -->
 
 <PickupRepresentation
     pickupName = "Small Shield Pickup"
-    pickupDescription = "Gives you a small shield for 10 seconds."
+    pickupDescription = "Gives you a small-sized shield for 30 seconds."
     inventoryRepresentation = "SmallShield"
     spawnerTemplate = "smallshieldpickupRepresentation"
@@ -197,2 +198,14 @@
 </PickupRepresentation>
 
+<!-- Drone Pickup -->
+
+<PickupRepresentation
+    pickupName = "Drone Pickup"
+    pickupDescription = "Adds a Drone to the Players Spaceship"
+    spawnerTemplate = "dronepickupRepresentation"
+>
+    <pickup>
+        <DronePickup template=dronepickup />
+    </pickup>
+</PickupRepresentation>
+
Index: /code/branches/presentation3/data/levels/pickups.oxw
===================================================================
--- /code/branches/presentation3/data/levels/pickups.oxw	(revision 7037)
+++ /code/branches/presentation3/data/levels/pickups.oxw	(revision 7038)
@@ -29,12 +29,4 @@
     <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
     <SpawnPoint position="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
-
-    <!-- Drone pickup -->
-
-    <PickupSpawner position="-100,0,-100" triggerDistance="10" respawnTime="30" maxSpawnedItems="10">
-        <pickup>
-            <DronePickup droneTemplate=droneTemplate />
-        </pickup>
-    </PickupSpawner>
 
     <!-- Shield pickups -->
@@ -151,4 +143,14 @@
       </pickup>
     </PickupSpawner>
+    
+    <!-- Drone pickup -->
+    
+    <PickupSpawner position="-50,50,-125" triggerDistance="10" respawnTime="30" maxSpawnedItems="10">
+      <pickup>
+        <DronePickup template=dronepickup />
+      </pickup>
+    </PickupSpawner>
+    
+    <!-- Other pickups -->
 
     <!-- PickupRepresentation for the pickup below, since it is not a standard pickup provided by pickups.oxi -->
Index: /code/branches/presentation3/data/levels/templates/pickup_representation_templates.oxt
===================================================================
--- /code/branches/presentation3/data/levels/templates/pickup_representation_templates.oxt	(revision 7037)
+++ /code/branches/presentation3/data/levels/templates/pickup_representation_templates.oxt	(revision 7038)
@@ -26,5 +26,4 @@
   />
 </Template>
-
 
 <Template name=mediumshieldpickupRepresentation>
@@ -426,4 +425,6 @@
     </PickupCollection>
 </Template>
+
+<!-- Drone Pickup -->
 
 <Template name=droneTemplate>
@@ -458,2 +459,23 @@
     </Drone>
 </Template>
+
+<Template name=dronepickupRepresentation>
+    <PickupRepresentation>
+        <spawner-representation>
+            <StaticEntity>
+                <attached>
+                    <Billboard position="0,0,0" colour="0.96,0.35,0.02" material="Sphere2" scale=0.1>
+                        <attached>
+                            <Model scale="5" mesh="drone.mesh"/>
+                        </attached>
+                    </Billboard>
+                </attached>
+            </StaticEntity>
+        </spawner-representation>
+    </PickupRepresentation>
+</Template>
+
+<Template name=dronepickup>
+    <DronePickup droneTemplate=droneTemplate />
+</Template>
+
Index: /code/branches/presentation3/src/modules/pickup/PickupSpawner.cc
===================================================================
--- /code/branches/presentation3/src/modules/pickup/PickupSpawner.cc	(revision 7037)
+++ /code/branches/presentation3/src/modules/pickup/PickupSpawner.cc	(revision 7038)
@@ -223,5 +223,5 @@
         else
         {
-            COUT(3) << "PickupSpawner empty, selfdestruct initialized." << std::endl;
+            COUT(4) << "PickupSpawner (&" << this << ") empty, selfdestruct initialized." << std::endl;
             this->setActive(false);
             this->destroy();
@@ -248,10 +248,10 @@
         if(this->pickup_ != NULL)
         {
-            COUT(1) << "In PickupSpawner: setPickupable called, with this->pickup_ already set." << std::endl;
+            COUT(1) << "In PickupSpawner (&" << this << "): setPickupable called, with this->pickup_ already set." << std::endl;
             return;
         }
         if(pickup == NULL)
         {
-            COUT(1) << "In PickupSpawner: Argument of setPickupable is NULL." << std::endl;
+            COUT(1) << "In PickupSpawner (&" << this << "): Argument of setPickupable is NULL." << std::endl;
             return;
         }
@@ -282,5 +282,5 @@
         if (this->isActive()) //!< Checks whether PickupSpawner is active.
         {
-            COUT(3) << "PickupSpawner triggered and active." << std::endl;
+            COUT(4) << "PickupSpawner (&" << this << ") triggered and active." << std::endl;
             
             PickupCarrier* carrier = dynamic_cast<PickupCarrier*>(pawn);
@@ -293,5 +293,5 @@
             if(!carrier->isTarget(this->pickup_))
             {
-                COUT(4) << "PickupSpawner triggered but Pawn wasn't a target of the Pickupable." << std::endl;
+                COUT(4) << "PickupSpawner (&" << this << ") triggered but Pawn wasn't a target of the Pickupable." << std::endl;
                 return;
             }
@@ -314,9 +314,9 @@
             {
                 if(target == NULL)
-                    COUT(1) << "PickupSpawner: Pickupable has no target." << std::endl;
+                    COUT(1) << "PickupSpawner (&" << this << "): Pickupable has no target." << std::endl;
                 
                 if(pickup == NULL)
                 {
-                    COUT(1) << "PickupSpawner: getPickup produced an error, no Pickupable created." << std::endl;
+                    COUT(1) << "PickupSpawner (&" << this << "): getPickup produced an error, no Pickupable created." << std::endl;
                 }
                 else
@@ -352,5 +352,5 @@
     void PickupSpawner::respawnTimerCallback()
     {
-        COUT(3) << "PickupSpawner reactivated." << std::endl;
+        COUT(4) << "PickupSpawner (&" << this << ") reactivated." << std::endl;
 
         this->setActive(true);
Index: /code/branches/presentation3/src/orxonox/controllers/DroneController.cc
===================================================================
--- /code/branches/presentation3/src/orxonox/controllers/DroneController.cc	(revision 7037)
+++ /code/branches/presentation3/src/orxonox/controllers/DroneController.cc	(revision 7038)
@@ -97,5 +97,5 @@
     }
 
-    /*
+    /**
     @brief
         The controlling happens here. This method defines what the controller has to do each tick.